%define initdir /etc/rc.d/init.d

Name: tunnelv
Summary: VPN software
Version: 1.00
Release: 4
Copyright: LGPL
Group: Applications/Internet
Source: http://www.worldvisions.ca/tunnelv/tunnelv-%{version}.tar.gz
Source1: tunnelv.init
Source2: tunnelv.wrapper.in
Patch0: tunnelv-broken.patch
Patch1: tunnelv-1.00-config.patch
URL: http://www.worldvisions.ca/tunnelv/
BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildPrereq: openssl-devel perl sed sh-utils fileutils
Prereq: fileutils sh-utils /sbin/chkconfig /sbin/service
Requires: util-linux
Prefix: %{_prefix}

%description
Tunnel Vision creates an encrypted Virtual Private Network, or VPN, between
two Tunnel Vision-capable sites on the Internet. Realistically, that means
sites with a Linux server running Tunnel Vision or with a Worldvisions Weaver
acting as their Internet gateway. 

%prep
%setup -q
%patch0 -p1 -b .broken
%patch1 -p1 -b .config

%build
make PREFIX=%{prefix}

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{initdir}
mkdir -p $RPM_BUILD_ROOT/etc/sysconfig

(
  echo '[Tunnel Vision]';
  echo -n 'Magic Password = ';
  perl -e "\$a = pack ('u', rand (1000000000)); \$a =~ s/\`+$//g; print \$a;"
) > $RPM_BUILD_ROOT/etc/tunnelv.conf

make PREFIX=$RPM_BUILD_ROOT%{prefix} install

cp $RPM_SOURCE_DIR/tunnelv.init $RPM_BUILD_ROOT%{initdir}/tunnelv

cat << EOF > $RPM_BUILD_ROOT/etc/sysconfig/tunnelv
#MODE=client
MODE=server
REMOTEHOST=localhost
PORT=1234
EOF

cat $RPM_SOURCE_DIR/tunnelv.wrapper.in | sed 's#@PREFIX@#'%{prefix}'#g' > \
	$RPM_BUILD_ROOT%{prefix}/bin/tunnelv.wrapper

%post
/sbin/chkconfig --add tunnelv
for i in `seq 0 15`; do
        [ -c /dev/tap${i} ] || mknod /dev/tap${i} c 36 $(( 16 + ${i} ))
done

%preun
if [ "$1" = "0" ]; then
	/sbin/service tunnelv stop > /dev/null 2>&1
        /sbin/chkconfig --del tunnelv
fi

%postun
if [ "$1" -ge "1" ]; then
	/sbin/service tunnelv condrestart > /dev/null 2>&1
fi

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr (-, root, root, 755)
%doc CHANGES COPYING.LIB README TECHINFO
%attr(600, root, root) %config(noreplace) /etc/tunnelv.conf
%attr(600, root, root) %config(noreplace) /etc/sysconfig/tunnelv
%attr(755, root, root) %{initdir}/tunnelv
%attr(755, root, root) %{prefix}/bin/tunnelv
%attr(755, root, root) %{prefix}/bin/tunnelv.wrapper

%changelog
* Fri Mar  2 2001 Tim Powers <timp@redhat.com>
- rebuilt against openssl-0.9.6-1

* Tue Feb 06 2001 Than Ngo <than@redhat.com>
- fixed initscript (Bug #26292)

* Tue Jan 23 2001 Tim Powers <timp@redhat.com>
- updated initscript

* Tue Oct 24 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Minor spec cleanups
- Build for Powertools

* Mon Aug 14 2000 Than Ngo <than@redhat.com>
- use service to restart/stop service
- add /sbin/service to Prereq:

* Wed Jul 05 2000 Than Ngo <than@redhat.de>
- fix up initscript to work with old and new initscript directory
- define initdir macro to set the right initscript directory
- clean up specfile

* Tue Jul 04 2000 Than Ngo <than@redhat.de>
- /etc/rc.d/init.d -> /etc/init.d
- fix initscript
- add %requires initscripts >= 5.20
- add %prereq /sbin/chkconfig

* Tue Jun 27 2000 Than Ngo <than@redhat.de>
- built on ia64 with -O0 (compiler bug)
- add post/preun/postun to create devices
- remove devices from package
 
* Mon Jun 26 2000 Than Ngo <than@redhat.de>
- fix to build with the new gcc-2.96 on alpha and ia64

* Wed Jun 21 2000 Than Ngo <than@redhat.de>
- FHS fixes
- clean up specfile
- fix to built with the new gcc-2.96

* Fri Mar 31 2000 Nils Philippsen <nils@redhat.de>
- version 1.00
- initial build
